# std::chrono::ceil(std::chrono::duration)

From cppreference.com
< cpp‎ | chrono‎ | duration

Defined in header `<chrono>` |  |
template <class ToDuration, class Rep, class Period> constexpr ToDuration ceil(const duration<Rep, Period>& d); |  | (since C++17)

Returns the smallest duration `t` representable in `ToDuration` that is greater or equal to `d`.

The function does not participate in the overload resolution unless `ToDuration` is an instance of std::chrono::duration.

### Parameters

d | - | duration to convert

### Return value

`d` rounded up to a duration of type `ToDuration`.

### Possible implementation

    template <class T> struct is_duration : std::false_type {};
    template <class Rep, class Period> struct is_duration<
        std::chrono::duration<Rep, Period>> : std::true_type {};

    template <class To, class Rep, class Period,
              class = enable_if_t<is_duration<To>{}>>
    constexpr To ceil(const std::chrono::duration<Rep, Period>& d)
    {
        To t = std::chrono::duration_cast<To>(d);
        if (t < d)
            return t + To{1};
        return t;
    }

### Example

| This section is incomplete Reason: no example

### See also

duration_cast | converts a duration to another, with a different tick interval (function template)
floor(std::chrono::duration) (C++17) | converts a duration to another, rounding down (function template)
round(std::chrono::duration) (C++17) | converts a duration to another, rounding to nearest, ties to even (function template)
ceil(std::chrono::time_point) (C++17) | converts a time_point to another, rounding up (function template)
ceil | nearest integer not less than the given value (function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/chrono/duration/ceil&oldid=85597"
Category:

- Todo no example